////////////////////////////////////////////////////////////////////////////
// CUndoListMgr 饹Υץơ
//
////////////////////////////////////////////////////////////////////////////

#include "UndoListMgr.h"
#include "TaEditShell.h"

////////////////////////////////////////////////////////////////////////////
// /˴
////////////////////////////////////////////////////////////////////////////

CUndoListMgr::CUndoListMgr() :
	MaxUndoCount( 1000 )
{
	Clear();
}

CUndoListMgr::~CUndoListMgr()
{

}

////////////////////////////////////////////////////////////////////////////
// ᥽å
////////////////////////////////////////////////////////////////////////////

// Undoǽʺ
void CUndoListMgr::SetMaxUndoCount( int argCnt )
{
	assert( NULL != this && argCnt > 0 && argCnt <= INT_MAX );
	MaxUndoCount = argCnt;
}

// ɥǽݤ
bool CUndoListMgr::EnableUndo() const
{
	list< pair< bool, list< VClsPtr< CEditCommand > > > >::const_iterator wItr;
	assert( NULL != this );

	// ꥹȤΥ0ʤ顢⤽UndoԲǽǤ
	if ( listUndo.size() == 0 ) return false;

	// Ƭ򼨤ƤUndoԲǽ
	if ( listUndo.begin() == itrUndo ) return false;

	// 򼨤ƤUndoǽ
	if ( listUndo.end() == itrUndo ) return true;

	// ߤΥꥹȤꤵƤʤUndoԲ
	if ( !itrUndo->first ) return false;

	return true;
}

// ɥǽݤ
bool CUndoListMgr::EnableRedo() const
{
	assert( NULL != this );

	// ꥹȤΥ0ʤ顢⤽RedoԲǽǤ
	if ( listUndo.size() == 0 ) return false;

	// 򼨤ƤRedoԲ
	if ( listUndo.end() == itrUndo ) return false;

	// ߤΥꥹȤꤵƤʤRedoԲ
	if ( !itrUndo->first ) return false;

	return true;
}

// UndoѤԽޥɥ֥Ȥ
list< VClsPtr< CEditCommand > > CUndoListMgr::GetUndoObj()
{
	list< VClsPtr< CEditCommand > > wList;

	assert( NULL != this && EnableUndo() );

	itrUndo--;

	// ս¤ؤ
	wList = itrUndo->second;
	wList.reverse();

	// ˥塼򹹿
	UpdateMenuStatus();

	return wList;
}

// RedoѤԽޥɥ֥Ȥ
list< VClsPtr< CEditCommand > > CUndoListMgr::GetRedoObj()
{
	list< pair< bool, list< VClsPtr< CEditCommand > > > >::iterator  wItr;

	wItr = itrUndo;
	itrUndo++;

	// ˥塼򹹿
	UpdateMenuStatus();

	return wItr->second;
}

// Խޥɥ֥Ȥɲä
void CUndoListMgr::PushBack( VClsPtr< CEditCommand > pObj )
{
	assert( NULL != this );

	// itrUndoλؤƤꥹȤꤵ줿ʪǤäϡȾʬ
	if ( itrUndo != listUndo.end() ) {
		if ( itrUndo->first ) {
			listUndo.erase( itrUndo, listUndo.end() );
			itrUndo = listUndo.end();
		}
	}

	if ( itrUndo == listUndo.end() ) {
		// ꥹȤɲ
		list< VClsPtr< CEditCommand > > dmy;
		listUndo.push_back( pair< bool, list< VClsPtr< CEditCommand > > >( false, dmy ) );
		itrUndo--;

		// ꥹȤĶϡƬΤΤ
		if ( listUndo.size() > MaxUndoCount ) {
			list< pair< bool, list< VClsPtr< CEditCommand > > > >::iterator wItr = listUndo.begin();
			wItr++;
			listUndo.erase( listUndo.begin(), wItr );
		}
	}

	// Ǥɲä
	itrUndo->second.push_back( pObj );
}

// ԽλȤ򼨤
void CUndoListMgr::EndEdit()
{
	itrUndo->first = true;
	itrUndo = listUndo.end();

	UpdateMenuStatus();
}

// 
void CUndoListMgr::Clear()
{
	assert( NULL != this );
	listUndo.clear();
	itrUndo = listUndo.end();
}

// Undo/Redo˥塼ξ֤򹹿
void CUndoListMgr::UpdateMenuStatus() const
{
	assert( NULL != this );
	m_TaEditShell->SetEnableUndoMenu( EnableUndo() );
	m_TaEditShell->SetEnableRedoMenu( EnableRedo() );
}

// ꥹȤ򴹤
void CUndoListMgr::Swap( CUndoListMgr *p )
{
	assert( this && p );

	list< pair< bool, list< VClsPtr< CEditCommand > > > >::iterator wItr;
	int wInt;

	wInt = this->MaxUndoCount;
	this->MaxUndoCount = p->MaxUndoCount;
	p->MaxUndoCount = wInt;

	wItr = this->itrUndo;
	this->itrUndo = p->itrUndo;
	p->itrUndo = wItr;

	listUndo.swap( p->listUndo );
}

